! ==============================================================================
! Module: SYSTEMPARAM [ISRS VERSION]
! 
! Purpose: Contains the global variables needed in Saguaro.
!
! History:
!
! Version    Date         Comment
! --------   ----------   -----------------------
!            10/01/2010   Original Code
!
! Contains:
!
! Modules -
! Functions -
! Subroutines -
!
! Author(s): Eric Dykeman
!
! ==============================================================================

      MODULE SYSTEMPARAM

        IMPLICIT NONE


        !=== ALLOCATABLE ARRAYS ===!

        INTEGER, DIMENSION(:), ALLOCATABLE, SAVE :: itype,lmol,indgb
        INTEGER, DIMENSION(:), ALLOCATABLE, SAVE :: lcls,mgprm

        INTEGER, DIMENSION(:,:), ALLOCATABLE, SAVE :: lubd,lcbd,langl
        INTEGER, DIMENSION(:,:), ALLOCATABLE, SAVE :: ldihd,lex,l14
        INTEGER, DIMENSION(:,:), ALLOCATABLE, SAVE :: imol,lnpair

        DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE, SAVE :: q,amass

        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: rat,vel
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: dubd,dcbd
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: dangl
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: ddihd
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: dvdw
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: gbparm
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: hnpair
        DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE, SAVE :: gchar

        DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE, SAVE :: grot
        DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE, SAVE :: gbas
        DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE, SAVE :: cmat


        !=== VARIABLES ===!

        INTEGER, SAVE :: nsteps,nse,nsv,nsc,nsmap,nnpair,maxsi,igb,igbsa
        INTEGER, SAVE :: ircp,ipbc,isym,isim,icrd,ishk,iout,imin,itc,ipc
        INTEGER, SAVE :: ips,ibd,iag,idh,icou,ivdw,iseed,nord,nat,nbd
        INTEGER, SAVE :: nag,ndh,nex,n14,nhbd,nubd,ncbd,nmol,nev,nout
        INTEGER, SAVE :: nsbk,ngbp,ngrp,ncls,nsite,nbas,nrow,irep,ismth
        INTEGER, SAVE :: myproc,nproc,mrec(3)

        DOUBLE PRECISION, SAVE :: cut,scut,tole,tolf,diel,kappa,temp
        DOUBLE PRECISION, SAVE :: btemp,taut,taup,pres,comp,vol,time
        DOUBLE PRECISION, SAVE :: tstep,beta,bxgrd,sfc,sfv
        DOUBLE PRECISION, SAVE :: dlv(3,3),rlv(3,3),vir(3,3)
        DOUBLE PRECISION, SAVE :: evec(3),alpha(3),xint,taul

        LOGICAL, SAVE :: mpijob

        CHARACTER (LEN=80), SAVE :: rstfile

      END MODULE
